C     SUBRUTINA LINFIT
C
C     AJUSTA PUNTOS A UNA RECTA POR MINIMOS CUADRADOS
C            Y(I)=A*X(I)+B
C
C  DESCRIPCION DE LOS PARAMETROS
C
C     X   - VECTOR DE LA VARIABLE INDEPENDIENTE
C     Y   - VECTOR DE LA VARIABLE DEPENDIENTE
C     SY  - VECTOR DE LA DESVIACION ESTANDART DE Y
C     NPU - NUMERO DE PARES DE PUNTOS
C     MOD - DETREMINA EL METODO DE PESO DEL AJUSTE
C            1 => (INSTRUMENTAL) PES = 1./SY**2
C            0 => (SIN PESO) PES = 1.
C           -1 => (ESTADISTICO) PES = 1./Y
C     A   - PENDIENTE DE LA RECTA
C     SA  - DESVIACION ESTANDART DE A
C     B   - ORDENADA A X=0.
C     SB  - DESVIACION ESTANDART DE B
C     R   - COEFICIENTE DE CORRELACION LINEAL
C
C     SUBRUTINAS REQUERIDAS - NO
C
C     FUENTE, P. R. Bevington, Data reduction and error analysis
C                              for the physical sciences
C
C     David, 09/1998
C
      SUBROUTINE LINFIT(X,Y,SY,NPU,MOD,AA,SA,B,SB,R)
      DOUBLE PRECISION SUM, SUMX, SUMY, SUMX2, SUMXY, SUMY2
	REAL X(1),Y(1)
      DOUBLE PRECISION XI,YI,PES, DELTA, VAR
C      DOUBLE PRECISION X(1),Y(1)
      DIMENSION SY(1)
C
C       CALCULA LAS SUMAS CON PESO
C

      SUM=0.
      SUMX=0.
      SUMY=0.
      SUMXY=0.
      SUMX2=0.
      SUMY2=0.
C	WRITE (*,*) X,Y
      DO 50 I=1,NPU
      XI=X(I)
      YI=Y(I)
C	WRITE(*,*)XI,YI
	
      IF(MOD) 31,36,38
   31 IF(YI) 34,36,32
   32 PES=1./YI
      GOTO 41
   34 PES=1./(-YI)
      GOTO 41
   36 PES=1.
      GOTO 41
   38 PES=1./(SY(I))**2
C
   41 SUM=SUM+PES
      SUMX=SUMX+PES*XI
      SUMY=SUMY+PES*YI
      SUMXY=SUMXY+PES*XI*YI
      SUMX2=SUMX2+PES*XI*XI
      SUMY2=SUMY2+PES*YI*YI
   50 CONTINUE
C
C       CALCULO DE COEFICIENTES Y DESVIACIONES ESTANDARTS
C
      DELTA=SUM*SUMX2-SUMX*SUMX
      AA=(SUMXY*SUM-SUMX*SUMY)/DELTA
      B=(SUMX2*SUMY-SUMX*SUMXY)/DELTA
      IF(MOD) 62,64,62
   62 VAR=1.
      GOTO 67
   64 C=FLOAT(NPU)-2.
      VAR=(SUMY2+B*B*SUM+A*A*SUMX2-2.*(B*SUMY+A*SUMXY-A*B*SUMX))/C
   67 SB=DSQRT(VAR*SUMX2/DELTA)
      SA=DSQRT(VAR*SUM/DELTA)
      R=(SUM*SUMXY-SUMX*SUMY)/DSQRT(DELTA*(SUM*SUMY2-SUMY*SUMY))
      RETURN
      END
