C     ROUTINE PeLeSqFiReVi  !!!
C
C    Chi-square fitting for NONEQUIDISTANT data
C
C    of the equation  Y(t) = A1+A2*cos(2PIft)+A3*sin(2PIft)
C    MA = 4 ( number of coeff. Ai)
C
C   # RECONSTRUYE EXACTAMENTE LA SERIE INICIAL TENIENDO EN CUENTA #
C   # COMO BASE DE TIEMPO LA POSICIN DESEADA DE MUESTREO         #
C
C     PARAMETROS DEL PROGRAMA
C
C     TI --- TIEMPO INICIAL (SEG)
C     TF --- TIEMPO FINAL (SEG)
C     TIN -- INTERVALO TOTAL DE ANALISIS (SEG)
C     NPA -- NUMERO DE DATOS PREVISTOS EN UN DIA DE ANALISIS
C     NPD -- NUMERO DE PARES DE DATOS
C     NDA -- NUMERO DE DATOS DE AJUSTE
C     PER -- VALOR DEL PERIODO DE RECONSTRUCCION
C     MA --- NUMERO DE COEFICIENTES
C     ISD -- NUMERO DE SERIES DE DATOS
C     DD --- JULIAN DAY
C     IA --- YEAR
C     IM --- MONTH
C     ID --- DAY (OF MONTH)
C     HH --- HOUR (UT)
C     MM --- MINUTE
C     SS --- SECOND
C     IST -- CADENCIA DE REGISTRO (MIN)
C     CAD -- CADENCIA DE REGISTRO (MIN)
C     NHA -- NUMERO DE HARMONICOS
C
C     SUBROUTINES AND FUNCTIONS REQUIERED:
C
C     JD(IA,IM,ID,DD)     --------------------------------> CONVERTS CALENDAR DATE TO JULIAN DAY
C     DATE(DD,II,JJ,KK)   --------------------------------> CONVERTS JULIAN DAY TO CALENDAR DATE
C     LFIT(X,XX,SIG,NDA,A,MA,LISTA,MA,COVAR,MA,CHISQ,T)---> CHI-SQUARE FIT (IN THE MAIN)
C
C
      DIMENSION Y(1000,5),X(1000),SIG(1000),XX(1000),A(4),LISTA(4),YY(5)
      DIMENSION COVAR(4,4),AMP(500,5),PHA(500,5),FF(500,5),PER(500,5)
      DIMENSION TIM(1000),DELT(1000),Z(1000),AM(5),BM(5),ITI(1000),ZZ(5)
      DIMENSION recta(1000),original(1000),CMM(1000,5),ITI2(1000)
      DOUBLE PRECISION RESIDUS(2000),BACK(2000),RD(2000)
      INTEGER IA2,IM2,ID2,DD2,HH2,MM2,SS2,DD1,NHA,NND,DATO,DATI,ISA
      INTEGER IA,IM,ID,DD,HH,MM,SS,IST,NDA,NPD,IDA,NPA,LIN,DATF,ND4
      integer spikes(2000),tsf(2000),iteracio
      REAL PI2,T,PE,TI,TF,TIN,CAD,FB,FE,SAM,DLT,SM,SIM,SAV
C
      CHARACTER*4 PAR(5),EXTI,EXTO
      CHARACTER*5 EXTS,ESTA
      CHARACTER*12 TIME	
      CHARACTER*8 HEAD
      CHARACTER*18 NAM
      CHARACTER*22 NAMI,NAMO
      CHARACTER*23 NOOMS
C
 1000 FORMAT(A8)
 1100 FORMAT(I1,1X,A5,1X,A12,2F7.2,2I4) 
 2000 FORMAT(A4,': ',F8.2)
 2500 FORMAT(2X,I4,5(1X,I2),8X,I4,5(1X,I2))
 3000 FORMAT(I4,5(1X,I2),9X,F7.3,3X,F6.2)
 4000 FORMAT('PERIODO:',F6.2,', AMPLITUD:',F8.4,', FASE:',F8.5)
 5000 FORMAT(F8.2,F10.2,12F8.2)
 6000 FORMAT(I3,4F8.2)
 7000 FORMAT(20X,F8.2,F8.2)
C
C   DATA NEEDED
C
      spikes=0
      PI2=8.0*atan(1.0)
      ISA=1
      ISD=2
      NHA=64
      MA=3
      PAR(1)='f0F2'
      PAR(2)='muf '
      PAR(3)='hmF2'
      EXTI='.txt'
      EXTO='.dat'
      EXTS='R.dat'
C
C     OPEN FILE inici WHICH CONTAINS INFO ABOUT STATIONS
      OPEN(3,FILE='inici',STATUS='OLD')
      READ(3,1000) HEAD
    5 READ(3,1100,END=999) IFLAG,ESTA,TIME,ALATI,ALONG,IHE,IST
 	IF (IFLAG.EQ.0) GOTO 5
C
      NAMI=ESTA//'_'//TIME//EXTI
      NAMO=ESTA//'_'//TIME//EXTO
      NOOMS=ESTA//'_'//TIME//EXTS
C
      iteracio=0   
      NN=0
   25 OPEN(1,FILE=NAMI,STATUS='OLD')
      DO I=1,8
         READ(1,1000) HEAD
      ENDDO
C
C     CALCULATION INTERVAL LENGHT (SEG) AND FINAL PERIOD FOR THE ANALYSIS
C
      READ(1,2500) IA,IM,ID,HH,MM,SS,IA2,IM2,ID2,HH2,MM2,SS2
      CALL JD(IA,IM,ID,DD1)
      CALL JD(IA2,IM2,ID2,DD2)
      TI=FLOAT(HH*60*60+MM*60)
      TF=FLOAT((DD2-DD1)*24*60*60+HH2*60*60+MM2*60)
      TIN=TF-TI
      DATI=HH*60*60+MM*60
      DATF=(DD2-DD1)*24*60*60+HH2*60*60+MM2*60
C
      DO I=1,8
         READ(1,1000) HEAD
      ENDDO
C
C   READING DATA AND DETERMINATION OF LISTA AND SIG.
C
    3 READ(1,3000,ERR=3) IA,IM,ID,HH,MM,SS,(SAV,J=1,ISD)
      IF(ESTA.EQ.'JR055') MM=MM+2
C
C   Julian Day
C
      CALL JD(IA,IM,ID,DD)
      DATO=(DD-DD1)*24*60*60+HH*60*60+MM*60+SS
C      write(*,*)IA,IM,ID,HH,MM,SS,DATO
C      PAUSE
      BACKSPACE(1)
    
      K=0
      KK=0
      SUMMUF=0
      ACMUF=0	
C
      GOTO 7
    6 K=K-1
    7 CONTINUE
      K=K+1
C
      READ(1,3000,ERR=6,END=10) IA,IM,ID,HH,MM,SS,(CMM(K,J),J=1,ISD)
C      write(*,*) (K,CMM(K,J),J=1,ISD)
C      PAUSE
      CALL JD(IA,IM,ID,DD)
      
    8 ITI2(K)=(DD-DD1)*24*60*60+HH*60*60+MM*60

C    SPIKE ELIMINATION
      IF (NN.EQ.0) THEN
      Y(K,1)=CMM(K,1)  
      Y(K,2)=CMM(K,2)
      ITI(K)=ITI2(K)   
      ELSE
      DO I=1,NN
      IF (K.eq.1 .or. ITI2(K).NE.tsf(I)) THEN
      Y(K,1)=CMM(K,1)  
      Y(K,2)=CMM(K,2)
      ITI(K)=ITI2(K)   
      ELSE
      K=K-1
      ENDIF
      ENDDO
      ENDIF 
      SUMMUF=SUMMUF+Y(K,2)
      TIM(K)=FLOAT(ITI(K))
      X(K)=FLOAT(K-1)
      SIG(K)=1.0
      GOTO 7
   10 CONTINUE
      NDA=K-1

      AVMUF=SUMMUF/NDA
      DO J=1,NDA
	VARMUF=(Y(J,2)-AVMUF)*(Y(J,2)-AVMUF)
	ACMUF=ACMUF+VARMUF
      ENDDO
      DO I=1,NDA
	original(I)=Y(I,2)
      ENDDO	
      SY=SQRT(ACMUF/NDA)
      CALL LINFIT(TIM,Y(I,2),SY,NDA,0,AA,SA,B,SB,R)
C
C     CALCULATION OF DOMINANT SAMPLING CADENCE
C
      DO J=1,NDA-1
         DELT(J)=(TIM(J+1)-TIM(J))/60.
      ENDDO
      CALL AMEDI(DELT,NDA-1,CAD)
C
      IST=INT(CAD)
      NPA=TIN/60/IST
      PE=FLOAT(NDA)
      FB=0.5
      FE=1./(FLOAT(NDA))
      NHA=((FB-FE)/FE)+1
      ND4=2+NHA*12/NDA
      CLOSE(1)
C      write(*,*) NDA,IST,NPA,PE,NHA
C
C
      DO 20 I=1,MA
      LISTA(I)=I
   20 CONTINUE
C
C   CALCULATION
C
      DO 50 K=1,ISD
      DO 30 I=1,NDA
      XX(I)=Y(I,K)
      Z(I)=((TIM(I)-DATO)/60./CAD)
   30 CONTINUE
      DO 40 J=1,NHA
      T=PE/FLOAT(J)
C
C   CHI-SQUARE FITTING
C
      CALL LFIT(X,XX,SIG,NDA,A,MA,LISTA,MA,COVAR,MA,CHISQ,T)
C
C   DETERMINATION OF AMPLITUDES AND PHASES
C
      AM(K)=A(1)
      AMP(J,K)=SQRT(A(2)*A(2)+A(3)*A(3))
      PHA(J,K)=ATAN2(A(3),A(2))
      PER(J,K)=T
      FF(J,K)=1.0/T
   40 CONTINUE
   50 CONTINUE
C
C
      DO 70 K=1,ISD
      DO 60 J=1,NHA
   60 CONTINUE
   70 CONTINUE
C
C   CALCULATION OF FUNCTIONS AND
C   WRITING RESULTS
C
      DO 100 I=1,NDA
      SA1=TIM(I)-TI
      NND=(TIM(I)-TIM(I+1))/ISA
      DLT=ISA/(TIM(I)-TIM(I+1))
      XX(I)=FLOAT(IST)*(X(I)+1.)
      DO 90 K=1,ISD
      YY(K)=0.
      DO 80 J=1,NHA-1
      YY(K)=YY(K)+AMP(J,K)*COS(PI2*FF(J,K)*X(I)-PHA(J,K))
   80 CONTINUE
      YY(K)=YY(K)+AM(K)
   90 CONTINUE
C
  100 CONTINUE
C
C   GENERATION OF THE RECONSTRUCTED NEW DATA SERIE
C
      OPEN(2,FILE=NOOMS,STATUS='UNKNOWN')
C
C   CHECK DATA IN THE BEGINING. IF IS NEEDED FILL WITH -99.9
C
      LIN=0
      NND=0
      SAM=0
      IF((DATI+SS2).LT.DATO) THEN
      NND=(DATO-DATI-SS2)/60/ISA
      DO 130 I=1,NND
      LIN=LIN+1
      SIM=LIN*ISA
	IF (SIM.gt.1080) then
      WRITE(2,6000) LIN-1080,(-99.9,-99.9,K=1,ISD)
	endif
  130 CONTINUE
      ENDIF
C
C   CHECK IF IS THE APPROPRIATE SAMPLING, IF NOT REBUILD
C
      DO 170 I=1,(NDA-1)
      SAV=(ITI(I+1)-ITI(I)+30)/60/ISA
      NND=INT(SAV)
      NND_GENERAL=NND 
      SAM=(TIM(I)-DATI)/60
      DO 160 L=1,NND
      SM=FLOAT(I-1)+FLOAT((L-1)*ISA)/FLOAT(NND)
C
      LIN=LIN+1
      DO 150 K=1,ISD
      ZZ(K)=0.
      YY(K)=0.
C
      DO 140 J=(ND4+1),NHA-1
      YY(K)=YY(K)+AMP(J,K)*COS(PI2*FF(J,K)*SM-PHA(J,K))
  140 CONTINUE
      DO 145 J=1,ND4
      ZZ(K)=ZZ(K)+AMP(J,K)*COS(PI2*FF(J,K)*SM-PHA(J,K))
  145 CONTINUE
      ZZ(K)=ZZ(K)+AM(K)
  150 CONTINUE
      SIM=LIN*ISA
	IF (SIM.gt.1080) then
      WRITE(2,6000) LIN-1080,(YY(K),ZZ(K),K=1,ISD)
	endif

  160 CONTINUE
  170 CONTINUE
C
C   ADD THE LAST MEASURED VALUE
C
      SM=FLOAT(NDA-1)
      LIN=LIN+1
      DO 190 K=1,ISD
      SAM=(ITI(I)-DATI)/60
      YY(K)=0.
      ZZ(K)=0.
      DO 180 J=(ND4+1),NHA-1
      YY(K)=YY(K)+AMP(J,K)*COS(PI2*FF(J,K)*SM-PHA(J,K))
  180 CONTINUE
      DO 185 J=1,ND4
      ZZ(K)=ZZ(K)+AMP(J,K)*COS(PI2*FF(J,K)*SM-PHA(J,K))
  185 CONTINUE
      ZZ(K)=ZZ(K)+AM(K)
  190 CONTINUE
      SIM=LIN*ISA
      WRITE(2,6000) LIN-1080,(YY(K),ZZ(K),K=1,ISD)

C
C   CHECK THERE IS NO MISSING DATA AT THE END
C

      SAM=(TIM(NDA)-DATI)/60

      IF(ITI(NDA).LT.DATF) THEN
      NND=(DATF-ITI(NDA))/60/ISA
      
      DO 220 L=1,NND+1
      SM=FLOAT(NDA-1)+L/FLOAT(NND)


      LIN=LIN+1
      SIM=LIN*ISA

      DO 300 K=1,ISD
      ZZ(K)=0.
      YY(K)=0.
      DO 310 J=(ND4+1),NHA-1
      YY(K)=YY(K)+AMP(J,K)*COS(PI2*FF(J,K)*SM-PHA(J,K))

  310 CONTINUE
      DO 315 J=1,ND4
      ZZ(K)=ZZ(K)+AMP(J,K)*COS(PI2+FF(J,K)*SM-PHA(J,K))
  315 CONTINUE
      ZZ(K)=ZZ(K)+AM(K)
  300 CONTINUE
      TIM(L)=FLOAT(ITI(NDA)+L)

      WRITE(2,6000) LIN-1080,(YY(K),ZZ(K),K=1,ISD)
 
  220 CONTINUE
      ENDIF
      CLOSE(2)
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     BLOCK FOR THE SPIKE DETERMINATION
C
      iteracio=iteracio+1
      NDS=360
      sumsp=0
      sumrd=0
      sumback=0
      AV=0
      BACK=0
      RESIDUS=0
      ACBAC=0
      ACBRD=0
      ACBBACK=0
      open(2,FILE=NOOMS,STATUS='OLD')
      read(2,7000,END=888) (RESIDUS(I),BACK(I), I=1,NDS)
  888 CONTINUE

      DO I=1,NDS
      sumsp=sumsp+RESIDUS(I)
      sumback=sumback+BACK(I)  
      ENDDO
      AV=sumsp/NDS
      AVBACK=sumback/NDS
      DO I=1,NDS
	VAR=(RESIDUS(I)-AV)*(RESIDUS(I)-AV)
	ACBAC=ACBAC+VAR
        ACBRD=ACBRD+VARRD
        VARBACK=(BACK(I)-AVBACK)*(BACK(I)-AVBACK)
        ACBBACK=ACBBACK+VARBACK
      ENDDO
      SYSP=SQRT(ACBAC/NDS)
      SYSBACK=SQRT(ACBBACK/NDS)
      J=0
      DO 330 I=1,NDS
      IF (RESIDUS(I).GT.3*SYSP .OR. RESIDUS(I).LT.-3*SYSP
     * .OR. ABS(RESIDUS(I)).GT.5) THEN
      J=J+1
      spikes(J)=I
      ENDIF 
  330 CONTINUE
      NN=NN+J
      DO J=1,NN
	tsf(J)=HH2*60*60+(MM2+1080+spikes(J))*60
      ENDDO
      close(2)
      IF(NN.GT.0 .AND. iteracio.LT.2) GOTO 25
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C
C CONTINUE HERE
C
      GOTO 5
  999 CONTINUE
      CLOSE(3)
      END
C
      SUBROUTINE LFIT(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,
     *CHISQ,T)
      PARAMETER (MMAX=50)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MA),
     * COVAR(NCVM,NCVM),BETA(MMAX),AFUNC(MMAX)
      REAL T
      INTEGER MA,MFIT,NCVM,IHTI,KK,NDATA
      KK=MFIT+1
      DO 12 J=1,MA
        IHIT=0
        DO 11 K=1,MFIT
          IF (LISTA(K).EQ.J) IHIT=IHIT+1
11      CONTINUE
        IF (IHIT.EQ.0) THEN
          LISTA(KK)=J
          KK=KK+1
        ELSE IF (IHIT.GT.1) THEN
          PAUSE 'Improper set in LISTA'
        ENDIF
12    CONTINUE
      IF (KK.NE.(MA+1)) PAUSE 'Improper set in LISTA'
      DO 14 J=1,MFIT
        DO 13 K=1,MFIT
          COVAR(J,K)=0.
13      CONTINUE
        BETA(J)=0.
14    CONTINUE
      DO 18 I=1,NDATA
        CALL FUNCS(X(I),T,AFUNC,MA)
        YM=Y(I)
        IF(MFIT.LT.MA) THEN
          DO 15 J=MFIT+1,MA
            YM=YM-A(LISTA(J))*AFUNC(LISTA(J))
15        CONTINUE
        ENDIF
        SIG2I=1./SIG(I)**2
        DO 17 J=1,MFIT
CC
C      WRITE(*,*) YM,Y(I),X(I),J,A(LISTA(J)),AFUNC(LISTA(J))
C      PAUSE
CC
          WT=AFUNC(LISTA(J))*SIG2I
          DO 16 K=1,J
            COVAR(J,K)=COVAR(J,K)+WT*AFUNC(LISTA(K))
16        CONTINUE
          BETA(J)=BETA(J)+YM*WT
17      CONTINUE
18    CONTINUE
      IF (MFIT.GT.1) THEN
        DO 21 J=2,MFIT
          DO 19 K=1,J-1
            COVAR(K,J)=COVAR(J,K)
19        CONTINUE
21      CONTINUE
      ENDIF
      CALL GAUSSJ(COVAR,MFIT,NCVM,BETA,1,1)
      DO 22 J=1,MFIT
        A(LISTA(J))=BETA(J)
22    CONTINUE
      CHISQ=0.
      DO 24 I=1,NDATA
        CALL FUNCS(X(I),T,AFUNC,MA)
        SUM=0.
        DO 23 J=1,MA
          SUM=SUM+A(J)*AFUNC(J)
23      CONTINUE
        CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
24    CONTINUE
      CALL COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      RETURN
      END
CC
CC
      SUBROUTINE COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      DIMENSION COVAR(NCVM,NCVM),LISTA(MFIT)
      DO 12 J=1,MA-1
        DO 11 I=J+1,MA
          COVAR(I,J)=0.
11      CONTINUE
12    CONTINUE
      DO 14 I=1,MFIT-1
        DO 13 J=I+1,MFIT
          IF(LISTA(J).GT.LISTA(I)) THEN
            COVAR(LISTA(J),LISTA(I))=COVAR(I,J)
          ELSE
            COVAR(LISTA(I),LISTA(J))=COVAR(I,J)
          ENDIF
13      CONTINUE
14    CONTINUE
      SWAP=COVAR(1,1)
      DO 15 J=1,MA
        COVAR(1,J)=COVAR(J,J)
        COVAR(J,J)=0.
15    CONTINUE
      COVAR(LISTA(1),LISTA(1))=SWAP
      DO 16 J=2,MFIT
        COVAR(LISTA(J),LISTA(J))=COVAR(1,J)
16    CONTINUE
      DO 18 J=2,MA
        DO 17 I=1,J-1
          COVAR(I,J)=COVAR(J,I)
17      CONTINUE
18    CONTINUE
      RETURN
      END
CCC
CCC
      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP)
      PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                PAUSE 'Singular matrix'
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) PAUSE 'Singular matrix.'
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END
CC
CC
      SUBROUTINE FUNCS(X,T,AFUNC,MA)
      DIMENSION AFUNC(MA)
      REAL PI2
      PI2=8.0*ATAN(1.0)
      F=1./T
      AFUNC(1)=1.0
C      AFUNC(4)=(Z-zm)/zm
      AFUNC(2)=COS(PI2*F*X)
      AFUNC(3)=SIN(PI2*F*X)
      RETURN
      END
      SUBROUTINE AMEDI(A,N,AMED)
C
C
C
      DIMENSION A(1)
C
C     SORT THE DATA
C
      DO 3 I=1,N
      DO 2 J=I,N
      IF(A(I)-A(J)) 1,2,2
    1 F=A(I)
      A(I)=A(J)
      A(J)=F
    2 CONTINUE
    3 CONTINUE
C
C     Delete ZERO values
C
      DO 4 I=1,N
      IF(A(I).LE.0) GO TO 5
    4 CONTINUE
      GO TO 6
    5 N=I-1
    6 CONTINUE
      IF(N.EQ.0) AMED=0
      IF(N.EQ.0) GO TO 10
C
C     COMPUTE MEDIAN VALUE
C
      N2=N/2
      AMED=A(N2+1)
      IF(MOD(N,2).EQ.0) AMED=(A(N2+1)+A(N2))/2
   10 CONTINUE
      RETURN
      END
