C     ROUTINE PeLeSqFiReVi  !!!
C
C     Adaptation of ROUTINE PeLeSqFiReVi
C    Take advantage of some parameters, as number of data expected
C    to evaluate the percentage of data contained in one file respect
C    the expected data  
C
C
C     PARAMETROS DEL PROGRAMA
C
C     TI --- TIEMPO INICIAL (SEG)
C     TF --- TIEMPO FINAL (SEG)
C     TIN -- INTERVALO TOTAL DE ANALISIS (SEG)
C     NPA -- NUMERO DE DATOS PREVISTOS EN UN DIA DE ANALISIS
C     NPD -- NUMERO DE PARES DE DATOS
C     NDA -- NUMERO DE DATOS DE AJUSTE
C     PER -- VALOR DEL PERIODO DE RECONSTRUCCION
C     MA --- NUMERO DE COEFICIENTES
C     ISD -- NUMERO DE SERIES DE DATOS
C     DD --- JULIAN DAY
C     IA --- YEAR
C     IM --- MONTH
C     ID --- DAY (OF MONTH)
C     HH --- HOUR (UT)
C     MM --- MINUTE
C     SS --- SECOND
C     IST -- CADENCIA DE REGISTRO (MIN)
C     CAD -- CADENCIA DE REGISTRO (MIN)
C     NHA -- NUMERO DE HARMONICOS
C
C     SUBROUTINES AND FUNCTIONS REQUIERED:
C
C     JD(IA,IM,ID,DD)     --------------------------------> CONVERTS CALENDAR DATE TO JULIAN DAY
C     DATE(DD,II,JJ,KK)   --------------------------------> CONVERTS JULIAN DAY TO CALENDAR DATE
C
C
      DIMENSION Y(1000,5),X(1000),SIG(1000),A(4)
      DIMENSION TIM(1000),DELT(1000),ITI(1000)
      INTEGER IA2,IM2,ID2,DD2,HH2,MM2,SS2,DD1,NHA,NND,DATO,DATI,Ipercent
      INTEGER IA,IM,ID,DD,HH,MM,SS,IST,NDA,NPD,NPA,DATF,ND4
      REAL PE,TI,TF,TIN,CAD,FB,FE
C
      CHARACTER*4 PAR(5),EXTI,EXTO
      CHARACTER*5 EXTS
      CHARACTER*8 HEAD
      CHARACTER*18 NAM
      CHARACTER*22 NAMI,NAMO
      CHARACTER*23 NOOMS
C
 1000 FORMAT(A8)
 1100 FORMAT(A18)
 2500 FORMAT(2X,I4,5(1X,I2),8X,I4,5(1X,I2))
 3000 FORMAT(I4,5(1X,I2),9X,F7.3,3X,F6.2)
C
C   DATA NEEDED
C
      ISD=2
      NHA=64
      MA=3
      PAR(1)='f0F2'
      PAR(2)='muf '
      PAR(3)='hmF2'
      EXTI='.txt'
      EXTO='.dat'
      EXTS='R.dat'
C
      OPEN(3,FILE='INI',STATUS='OLD')
      READ(3,1000) HEAD
    5 READ(3,1100,END=999) NAM
C
      NAMI=NAM//EXTI
      NAMO=NAM//EXTO
      NOOMS=NAM//EXTS
C
      OPEN(1,FILE=NAMI,STATUS='OLD')
      DO I=1,8
         READ(1,1000) HEAD
      ENDDO
C
C     LENGHT CALCULATION OF DATA INTERVAL (SEC)
C
      READ(1,2500) IA,IM,ID,HH,MM,SS,IA2,IM2,ID2,HH2,MM2,SS2
      CALL JD(IA,IM,ID,DD1)
      CALL JD(IA2,IM2,ID2,DD2)
      TI=FLOAT(HH*60*60+MM*60+18*60*60)
      TF=FLOAT((DD2-DD1)*24*60*60+HH2*60*60+MM2*60)
      TIN=TF-TI
      DATI=HH*60*60+MM*60
      DATF=(DD2-DD1)*24*60*60+HH2*60*60+MM2*60
C
      DO I=1,8
         READ(1,1000) HEAD
      ENDDO
C
C   READING DATA AND DETERMINATION OF LISTA Y SIG.
C
      READ(1,3000) IA,IM,ID,HH,MM,SS

C
C   Julian Day
C
      CALL JD(IA,IM,ID,DD)
      DATO=(DD-DD1)*24*60*60+HH*60*60+MM*60+SS
      BACKSPACE(1)

      K=0
      KK=0
C
      GOTO 7
    6 K=K-1
    7 CONTINUE
      K=K+1
C
      READ(1,3000,ERR=6,END=10) IA,IM,ID,HH,MM,SS,(Y(K,J),J=1,ISD)

      CALL JD(IA,IM,ID,DD)
    8 ITI(K)=(DD-DD1)*24*60*60+HH*60*60+MM*60+SS
      TIM(K)=FLOAT(ITI(K))
      X(K)=FLOAT(K-1)
	
	if (TIM(K).gt.TI) nnn=nnn+1
      SIG(K)=1.0
      GOTO 7
   10 CONTINUE
      NDA=K-1
      
C
C     CALCULATION OF DOMINANT SAMPLING CADENCE
C
      DO J=1,NDA-1
         DELT(J)=(TIM(J+1)-TIM(J))/60.
      ENDDO
      CALL AMEDI(DELT,NDA-1,CAD)
C
      IST=INT(CAD)
      NPA=TIN/60/IST
      PE=FLOAT(NDA)
      FB=0.5
      FE=1./(FLOAT(NDA))
      NHA=((FB-FE)/FE)+1
      ND4=2+NHA*12/NDA


      CLOSE(1)
      nnn=nnn-1
      expected=NPA
      if (IST.gt.15) then
      Ipercent=0
      else
      Ipercent=INT((nnn/expected)*100)
      endif 
      write(*,*) Ipercent
      GOTO 5
  999 CONTINUE
      CLOSE(3)
C      STOP
      END
CCC
CC
CC
      SUBROUTINE AMEDI(A,N,AMED)
C
      DIMENSION A(1)
C
C     SORT THE DATA
C
      DO 3 I=1,N
      DO 2 J=I,N
      IF(A(I)-A(J)) 1,2,2
    1 F=A(I)
      A(I)=A(J)
      A(J)=F
    2 CONTINUE
    3 CONTINUE
C
C     Delete ZERO values
C
      DO 4 I=1,N
      IF(A(I).LE.0) GO TO 5
    4 CONTINUE
      GO TO 6
    5 N=I-1
    6 CONTINUE
      IF(N.EQ.0) AMED=0
      IF(N.EQ.0) GO TO 10
C
C     COMPUTE MEDIAN VALUE
C
      N2=N/2
      AMED=A(N2+1)
      IF(MOD(N,2).EQ.0) AMED=(A(N2+1)+A(N2))/2
   10 CONTINUE
      RETURN
      END
